%INCLUDE "common.asm"

SECTION .rodata:

;=============================================================================
; Code
;=============================================================================

SECTION .text:

   mt_mangle Logic, and8_mmx
   mt_mangle Logic, and8_isse
   mt_mangle Logic, and8_3dnow

   mt_mangle Logic, or8_mmx
   mt_mangle Logic, or8_isse
   mt_mangle Logic, or8_3dnow

   mt_mangle Logic, andn8_mmx
   mt_mangle Logic, andn8_isse
   mt_mangle Logic, andn8_3dnow

   mt_mangle Logic, xor8_mmx
   mt_mangle Logic, xor8_isse
   mt_mangle Logic, xor8_3dnow

   mt_mangle Logic, max8_isse
   mt_mangle Logic, max8_3dnow
   
   mt_mangle Logic, min8_isse
   mt_mangle Logic, min8_3dnow
   
%MACRO MT_LOGIC_ROLLED 1
   movq              mm0, [edi + eax]
   %1                mm0, [esi + eax]
   movq              [edi + eax], mm0
%ENDMACRO

%MACRO MT_LOGIC_UNROLLED 3
   %2                edi + eax + 384
   %3                esi + eax + 384

   movq              mm0, [edi + eax]
   movq              mm1, [edi + eax + 8]
   movq              mm2, [edi + eax + 16]
   movq              mm3, [edi + eax + 24]
   movq              mm4, [edi + eax + 32]
   movq              mm5, [edi + eax + 40]
   movq              mm6, [edi + eax + 48]
   movq              mm7, [edi + eax + 56]
   
   %1                mm0, [esi + eax]
   %1                mm1, [esi + eax + 8]
   %1                mm2, [esi + eax + 16]
   %1                mm3, [esi + eax + 24]
   %1                mm4, [esi + eax + 32]
   %1                mm5, [esi + eax + 40]
   %1                mm6, [esi + eax + 48]
   %1                mm7, [esi + eax + 56]
   
   movq              [edi + eax], mm0
   movq              [edi + eax + 8], mm1
   movq              [edi + eax + 16], mm2
   movq              [edi + eax + 24], mm3
   movq              [edi + eax + 32], mm4
   movq              [edi + eax + 40], mm5
   movq              [edi + eax + 48], mm6
   movq              [edi + eax + 56], mm7
%ENDMACRO

%MACRO MT_LOGIC_ENDLINE 0
   add                  edi, [esp + .nDstPitch]
   add                  esi, [esp + .nSrcPitch]
%ENDMACRO

%MACRO MT_LOGIC_COMMON  3
   MT_SET_STACK         0, esi, edi
   .pDst                PARAM(1)
   .nDstPitch           PARAM(2)
   .pSrc                PARAM(3)
   .nSrcPitch           PARAM(4)
   .nWidth              PARAM(5)
   .nHeight             PARAM(6)

   mov                  edi, [esp + .pDst]
   mov                  esi, [esp + .pSrc]
   
   MT_UNROLL_INPLACE_WIDTH  {MT_LOGIC_UNROLLED %1, %2, %3}, {MT_LOGIC_ROLLED %1}, MT_LOGIC_ENDLINE
   
   MT_REL_STACK
%ENDMACRO

and8_mmx :
   MT_LOGIC_COMMON pand, MT_NOPREFETCH, MT_NOPREFETCH
and8_isse :
   MT_LOGIC_COMMON pand, MT_PREFETCHT0, MT_PREFETCHT0
and8_3dnow :
   MT_LOGIC_COMMON pand, MT_PREFETCHW, MT_PREFETCHT0

or8_mmx :
   MT_LOGIC_COMMON por, MT_NOPREFETCH, MT_NOPREFETCH
or8_isse :
   MT_LOGIC_COMMON por, MT_PREFETCHT0, MT_PREFETCHT0
or8_3dnow :
   MT_LOGIC_COMMON por, MT_PREFETCHW, MT_PREFETCHT0

andn8_mmx :
   MT_LOGIC_COMMON pandn, MT_NOPREFETCH, MT_NOPREFETCH
andn8_isse :
   MT_LOGIC_COMMON pandn, MT_PREFETCHT0, MT_PREFETCHT0
andn8_3dnow :
   MT_LOGIC_COMMON pandn, MT_PREFETCHW, MT_PREFETCHT0

xor8_mmx :
   MT_LOGIC_COMMON pxor, MT_NOPREFETCH, MT_NOPREFETCH
xor8_isse :
   MT_LOGIC_COMMON pxor, MT_PREFETCHT0, MT_PREFETCHT0
xor8_3dnow :
   MT_LOGIC_COMMON pxor, MT_PREFETCHW, MT_PREFETCHT0

max8_isse :
   MT_LOGIC_COMMON pmaxub, MT_PREFETCHT0, MT_PREFETCHT0
max8_3dnow :
   MT_LOGIC_COMMON pmaxub, MT_PREFETCHW, MT_PREFETCHT0

min8_isse :
   MT_LOGIC_COMMON pminub, MT_PREFETCHT0, MT_PREFETCHT0
min8_3dnow :
   MT_LOGIC_COMMON pminub, MT_PREFETCHW, MT_PREFETCHT0   
