%INCLUDE "common.asm"

;=============================================================================
; Code
;=============================================================================

SECTION .text:

   mt_mangle Clamp, clamp8_isse
   mt_mangle Clamp, clamp8_3dnow
   
%MACRO MT_CLAMP_ROLLED 0
   movq        mm0, [esi + eax]
   movq        mm1, [ebx + eax]
   
   paddusb     mm0, mm6             ; overshoot
   psubusb     mm1, mm7             ; undershoot
   
   pminub      mm0, [edi + eax]
   pmaxub      mm0, mm1
   
   movq        [edi + eax], mm0
%ENDMACRO

%MACRO MT_CLAMP 1
   movq        mm0, [esi + eax + %1]
   movq        mm1, [esi + eax + %1 + 8]
   movq        mm2, [ebx + eax + %1]
   movq        mm3, [ebx + eax + %1 + 8]
   
   paddusb     mm0, mm6
   paddusb     mm1, mm6
   psubusb     mm2, mm7
   psubusb     mm3, mm7
   
   pminub      mm0, [edi + eax + %1]
   pminub      mm1, [edi + eax + %1 + 8]
   pmaxub      mm0, mm2
   pmaxub      mm1, mm3
   
   movq        [edi + eax + %1], mm0
   movq        [edi + eax + %1 + 8], mm1
%ENDMACRO   

%MACRO MT_CLAMP_UNROLLED 2
   %1          edi + eax + 64
   %2          esi + eax + 64
   %2          ebx + eax + 64
   
   MT_CLAMP    0
   MT_CLAMP    16
   MT_CLAMP    32
   MT_CLAMP    48
   
%ENDMACRO

%MACRO MT_CLAMP_ENDLINE 0
   add                  edi, [esp + .nDstPitch]
   add                  esi, [esp + .nSrc1Pitch]
   add                  ebx, [esp + .nSrc2Pitch]
%ENDMACRO

%MACRO MT_CLAMP_COMMON 2
   MT_SET_STACK         0, edi, esi, ebx
   .pDst                PARAM(1)
   .nDstPitch           PARAM(2)
   .pSrc1               PARAM(3)
   .nSrc1Pitch          PARAM(4)
   .pSrc2               PARAM(5)
   .nSrc2Pitch          PARAM(6)
   .nWidth              PARAM(7)
   .nHeight             PARAM(8)
   .nOvershoot          PARAM(9)
   .nUndershoot         PARAM(10)
   
   mov                  edi, [esp + .pDst]
   mov                  esi, [esp + .pSrc1]
   mov                  ebx, [esp + .pSrc2]
   
   movd                 mm6, [esp + .nOvershoot]
   movd                 mm7, [esp + .nUndershoot]
   punpcklbw            mm6, mm6
   punpcklbw            mm7, mm7
   punpcklwd            mm6, mm6
   punpcklwd            mm7, mm7
   punpckldq            mm6, mm6
   punpckldq            mm7, mm7
   
   MT_UNROLL_INPLACE_WIDTH    {MT_CLAMP_UNROLLED %1, %2}, MT_CLAMP_ROLLED, MT_CLAMP_ENDLINE
      
   MT_REL_STACK
%ENDMACRO

clamp8_isse:
   MT_CLAMP_COMMON      MT_PREFETCHT0, MT_PREFETCHT0
   
clamp8_3dnow:
   MT_CLAMP_COMMON      MT_PREFETCHW, MT_PREFETCHT0  
