#include "forms.h"
#include <ostream>

namespace Filtering { namespace MaskTools { namespace Helpers { namespace Forms {

static String IntegerToString(int n)
{
   char buffer[10]; /* enough */
   sprintf(buffer, "%i", n);
   buffer[9] = 0;   /* just to be on the safe side */
   return buffer;
}

static String &append_vector(String &str, int nX, int nY)
{
   return str.append(IntegerToString(nX)).append(" ").append(IntegerToString(nY)).append(" ");
}

#define ZERO ( zero || !i || !j )

String CircleToString(int nRadius, bool zero)
{
   String result = "";

   for ( int i = -nRadius; i <= nRadius; i++ )
      for ( int j = -nRadius; j <= nRadius; j++ )
         if ( i * i + j * j <= nRadius * nRadius && ZERO )
            result = append_vector(result, i, j);

   return result;
}

String SquareToString(int nRadius, bool zero)
{
   String result = "";

   for ( int i = -nRadius; i <= nRadius; i++ )
      for ( int j = -nRadius; j <= nRadius; j++ )
         if ( ZERO )
            result = append_vector(result, i, j);

   return result;
}

String DiamondToString(int nRadius, bool zero)
{
   String result = "";

   for ( int i = -nRadius; i <= nRadius; i++ )
      for ( int j = -nRadius; j <= nRadius; j++ )
         if ( abs(i) + abs(j) <= nRadius && ZERO )
            result = append_vector(result, i, j);
 
   return result;
}

String RectangleToString(int nHorizontalRadius, int nVerticalRadius, bool zero)
{
   String result = "";

   for ( int i = -nHorizontalRadius; i <= nHorizontalRadius; i++ )
      for ( int j = -nVerticalRadius; j <= nVerticalRadius; j++ )
         if ( ZERO )
            result = append_vector(result, i, j);
 
   return result;
}

String LosangeToString(int nHorizontalRadius, int nVerticalRadius, bool zero)
{
   String result = "";

   for ( int i = -nHorizontalRadius; i <= nHorizontalRadius; i++ )
      for ( int j = -nVerticalRadius; j <= nVerticalRadius; j++ )
         if ( abs(i) * nVerticalRadius + abs(j) * nHorizontalRadius <= nHorizontalRadius * nVerticalRadius && ZERO )
            result = append_vector(result, i, j);
 
   return result;
}

String EllipseToString(int nHorizontalRadius, int nVerticalRadius, bool zero)
{
   String result = "";

   for ( int i = -nHorizontalRadius; i <= nHorizontalRadius; i++ )
      for ( int j = -nVerticalRadius; j <= nVerticalRadius; j++ )
         if ( i * i * nVerticalRadius * nVerticalRadius + j * j * nHorizontalRadius * nHorizontalRadius <= nHorizontalRadius * nHorizontalRadius * nVerticalRadius * nVerticalRadius && ZERO )
            result = append_vector(result, i, j);
 
   return result;
}

} } } }